package com.googlecode.reflective.doc

import java.lang.reflect.Method
import com.thoughtworks.paranamer.{BytecodeReadingParanamer, Paranamer}

/**
 * 
 *
 * @author Matt Hicks <mhicks@sgine.org>
 */
class ParanamerDocReflection(paranamer: Paranamer) extends DocumentationReflection {
  def method(m: Method) = {
    val argNames = paranamer.lookupParameterNames(m, true)
    val args = m.getParameterTypes.toList.zip(argNames).map(t2dc)
    val returnClass = DocumentedClass(null, m.getReturnType, None)
    MethodDocumentation(args, returnClass, null, None)
  }

  private def t2dc(t: (Class[_], String)) = t match {
    case (c, s) => DocumentedClass(s, c, None)
  }
}

object ParanamerDocReflection extends DocMapper {
  lazy val default = new ParanamerDocReflection(new BytecodeReadingParanamer())

  def apply(c: Class[_]) = default
}